"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extract = extract;
exports.mark = mark;
exports.refer = refer;
function mark(data, type, transformMethod) {
  return {
    data: transformMethod ? data[transformMethod]() : data,
    __serializedType__: type
  };
}
function extract(data, type) {
  return {
    data: Object.assign({}, data),
    __serializedType__: type
  };
}
function refer(data, type, transformMethod, refs) {
  const r = mark(data, type, transformMethod);
  if (!refs) return r;
  for (let i = 0; i < refs.length; i++) {
    const ref = refs[i];
    if (typeof ref === 'function' && data instanceof ref) {
      r.__serializedRef__ = i;
      return r;
    }
  }
  return r;
}